# MML (mml-pypi)
My Machine Learning (MML) Library (developed by`Nathmath`/`DOF Studio`), identified as `mml-pypi` on PyPI.

A hybrid backend (`numpy` or `torch`) machine learning and deep learning framework coding from scratch.

It is a fantastic toolkit for machine learning teaching, learning, quick application with production level performance.

Another shining feature is its `AutoNeuralNetwork` framework - automatically build, train, fine-tune, and validate a neural network especially designed for non-professional groups.

# How to Install

pip install mml-pypi==0.0.4.2

import mml

# Version

MML 0.0.4.2 Released.

# License

Open sourced with Apache 2.0 License

# What's Inside?

What's inside? See below.

# Containers using Mixed Backends
* Matrix (For ML Algorithms) (numpy √ torch √)
* Tensor (For NN Framework) (numpy √ torch √)

# ML Algorithms from Scratch
* Linear Models (OLS and FGLS)
* Generalized Linear Models (FGLS with Actvation)
* Time Series Models (TS)
* Principal Component Analysis (PCA)
* Support Vector Machine (SVM)
* Classification And Regression Tree (CART)
* Linear Regression Tree Wrapper (LRTW)
* Random Forest (RF)
* Gradient Boosting Machine (GBM)
* Extreme Gradient Boosting Machine (XGBM)
* ...

# Neural Network Framework from Scratch
* Basic Module (nn_Module)
* Dense Layer (Dense)
* Dropout Layer (Dropout)
* Flatten Layer (Flatten)
* Stacked RNN Layer (StackedRNN)
* Stacked LSTM Layer (StackedLSTM)
* Loss Functions (MSE, RMSE, MAE, BinaryCrossEntropy, MultiCrossEntropy)
* Optimizers (SGD, Adam, AdamW)
* Easy Interface for Evaluation (Evaluator)
* ...

# Utils from Scratch

* Regression, Binary Classification, Multi Classification Metrics
* Train-Test Split, Train-Test Split for Time Series
* Data Scaler
* Data Wrangling Toolkits
* Easy Save and Load Interface
* Generic Optimizer
* Generic Bootstrap Sampler
* ..
